Subject: Re: [PATCH 12/13] sdhci: Add quirk for controllers with max. block size up to 4096 bytes

From: Anton Vorontsov <[email-masked]>
Date: Wed, 4 Mar 2009 20:47:44 +0300

On Sat, Feb 21, 2009 at 04:58:44PM +0100, Pierre Ossman wrote:
> On Fri, 13 Feb 2009 17:47:39 +0300
> Anton Vorontsov <[email-masked]> wrote:
> 
> > @@ -831,7 +832,12 @@ static void sdhci_prepare_data(struct sdhci_host *host, struct mmc_data *data)
> >  	sdhci_set_transfer_irqs(host);
> >  
> >  	/* We do not handle DMA boundaries, so set it to max (512 KiB) */
> > -	sdhci_writew(host, SDHCI_MAKE_BLKSZ(7, data->blksz), SDHCI_BLOCK_SIZE);
> > +	if (host->quirks & SDHCI_QUIRK_MAX_BLK_SZ_4096)
> > +		blksz = data->blksz;
> > +	else
> > +		blksz = SDHCI_MAKE_BLKSZ(7, data->blksz);
> > +
> > +	sdhci_writew(host, blksz, SDHCI_BLOCK_SIZE);
> >  	sdhci_writew(host, data->blocks, SDHCI_BLOCK_COUNT);
> >  }
> >  
> 
> Hmm.. I seem to have overlooked this part previously. I guess they've
> basically stripped out the DMA boundary stuff and used the bits for
> other things?

Yes, the last two "DMA boundary" bits are reserved, and the first
one is re-used for blksz of 4096 bytes.

> At this point I'm leaning more towards simply not supporting their
> extended block size.

Eh. But well, OK. We can always persuade you later. :-)

I'll get rid of this particular patch, and put some BLOCK_SIZE
magic into the writew accessor (to clean the DMA bits) instead.

Though, I'll prepare another patch to force blksz to 2048, since
eSDHC specifies "3" in the blksz capability bitfield, and that
causes SDHCI core to fall back to the 512 byte blocks.

> After all, is it ever used?

Not sure, maybe `dd bs=' can use it? A bit lazy to check this
right now, but from the quick tests, enabling/disabling "blksz
of 4096 bytes" doesn't cause any performance change. At least
with the ordinary SD cards.

-- 
Anton Vorontsov
email: [email-masked]
irc://irc.freenode.net/bd2